﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace RenderTransformBasic
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
        }

        private void slider1_ValueChanged(object sender, RoutedPropertyChangedEventArgs<double> e)
        {
            var m = new Matrix();

            m.RotateAt(e.NewValue * 36, layer1.ActualWidth / 2.0, layer1.ActualHeight / 2.0);
            layer1.RenderTransform = new MatrixTransform(m);
        }

        private void Grid_ManipulationStarting(object sender, ManipulationStartingEventArgs e)
        {
            e.ManipulationContainer = this;
        }

        private void Grid_ManipulationDelta(object sender, ManipulationDeltaEventArgs e)
        {
            ManipulationDelta delta = e.DeltaManipulation;
            Point origin = e.ManipulationOrigin;
            UIElement element = (UIElement)e.OriginalSource;
            Matrix m = element.RenderTransform.Value;

            m.RotateAt(delta.Rotation, origin.X, origin.Y);
            m.ScaleAt(delta.Scale.X, delta.Scale.Y, origin.X, origin.Y);
            m.Translate(delta.Translation.X, delta.Translation.Y);

            element.RenderTransform = new MatrixTransform(m);
        }
    }
}
